/*
* Quad Damage Script.
*  - Allows specific people to do 4x as much damage as normal.  Only usuable during fun mode.
*
* By Kndroc
*/


#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_QUAD 8192
#define CT 2
#define T 1
new autoquad = 0;

new STRING_VERSION[MAX_DATA_LENGTH] = "v1.0";
new Command[ MAX_TEXT_LENGTH ];
new Message[ MAX_TEXT_LENGTH ];
new quad1;
new quad2;

addDampQuad( uid )
{
	//the math here is
	//X = damage
	//so 4X is quad damage
	//but X damage was already done.  So X + 3X = 4X.  So quad damage to a victim is 3X since X was already applied.
	snprintf( Command, MAX_TEXT_LENGTH, "damp_add_rule %i 0.0 -3.0 0.0 0.0 0 0 0 0", uid );
	exec( Command );
}
delDampQuad( uid )
{
	snprintf( Command, MAX_TEXT_LENGTH, "damp_del_rule %i", uid );
	exec( Command );
}

issueQuad( Name[], uid, team )
{
	if( team == CT )
	{
		glow( Name,10,10,250);   //blue
	}
	else if( team == T )
	{
		glow(Name,250,10,10); //red
	}
	else //they are a VIP or something
	{
		glow(Name,250,250,250); //white
	}
	addDampQuad(uid);
}

stopQuad( Name[], uid )
{
	glow( Name, 0, 0, 0 );    //stop glowing
	delDampQuad( uid );
}

public admin_quad(HLCommand,HLData,HLUserName,UserIndex)
{
	if(getvar("admin_fun_mode") == 0) {
		say("Quad damage is only allowed during fun mode.");
		return PLUGIN_CONTINUE;
	}


	new Target[MAX_DATA_LENGTH];
	new Status[MAX_DATA_LENGTH];
	new Data[MAX_DATA_LENGTH];

	convert_string(HLData,Data,MAX_DATA_LENGTH);
	strbreak(Data,Target,Status, MAX_DATA_LENGTH);
	if(	strcmp(	Status, "1" )	== 0 )
	{
		if( check_user(Target) )
		{
			new Name[MAX_TEXT_LENGTH];
			new uid;
			new wonid;
			new team;
			new i;
			get_userindex(Target, i);
			if (playerinfo(i,Name,MAX_NAME_LENGTH, uid, wonid, team) == 1)
			{
				snprintf( Message, MAX_TEXT_LENGTH, "%s has been given Quad Damage", Name );
				typesay( Message, 6, 250, 10, 250 );
				issueQuad(Name, uid, team );
			}
		}
	}
	else
	{
		if( check_user(Target) )
		{
			new Name[MAX_TEXT_LENGTH];
			new uid;
			new i;
			get_userindex(Target, i);
			if (playerinfo(i,Name,MAX_NAME_LENGTH, uid) == 1)
			{
				snprintf( Message, MAX_TEXT_LENGTH, "%s has been stripped of Quad Damage", Name );
				typesay( Message, 6, 250, 10, 250 );
				stopQuad( Name, uid );
			}
		}
	}

	return PLUGIN_CONTINUE;
}

public admin_autoquad(HLCommand,HLData,HLUserName,UserIndex)
{
	if(getvar("admin_fun_mode") == 0) {
		say("Quad damage is only allowed during fun mode.");
		return PLUGIN_CONTINUE;
	}

	new Data[MAX_DATA_LENGTH];

	convert_string(HLData,Data,MAX_DATA_LENGTH);
	if(	strcmp(	Data, "1" )	== 0 )
	{
		typesay( "Auto-Quad enabled", 6, 250, 10, 250 );
		autoquad = 1;
	}
	else
	{
		autoquad = 0;
	}

	return PLUGIN_CONTINUE;
}

public quad_pick(HLCommand,HLData,HLUserName,UserIndex)
{
	if( autoquad == 0 )
	{
		return PLUGIN_CONTINUE;
	}
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);

	if( strcmp( Data, "Round_Start" ) == 0 )
	{
		new Name[MAX_TEXT_LENGTH];
		new uid;
		new wonid;
		new team;
		new Temp[MAX_TEXT_LENGTH] = "";
		new Temp2[MAX_TEXT_LENGTH] = "";
		new maxp = maxplayercount();
		new person = random(maxp) + 1;
		if (playerinfo(person,Name,MAX_NAME_LENGTH, uid, wonid, team) == 1)
		{
			snprintf( Temp, MAX_TEXT_LENGTH, "%s has been given Quad Damage", Name );
			quad1 = person;
			issueQuad(Name, uid, team );
		}
		person = random(maxp) + 1;
		if (playerinfo(person,Name,MAX_NAME_LENGTH, uid, wonid, team) == 1)
		{
			snprintf( Temp2, MAX_TEXT_LENGTH, "%s has been given Quad Damage", Name );
			quad2 = person;
			issueQuad(Name, uid, team );
		}
		snprintf( Message, MAX_TEXT_LENGTH, "%s^n%s", Temp, Temp2 );
		typesay( Message, 6, 250, 10, 250 );


	}
	else if ( strcmp( Data, "Round_End" ) == 0 )
	{
		new Name[MAX_TEXT_LENGTH];
		new uid;
		if (playerinfo(quad1,Name,MAX_NAME_LENGTH, uid) == 1)
		{
			stopQuad( Name, uid );
		}
		if (playerinfo(quad2,Name,MAX_NAME_LENGTH, uid) == 1)
		{
			stopQuad( Name, uid );
		}
	}

	return PLUGIN_CONTINUE;
}

public plugin_init()
{
	plugin_registerinfo("Controls Damp Team healing and Team Wounding",".",STRING_VERSION);
	plugin_registercmd("admin_quad", "admin_quad", ACCESS_QUAD, "admin_tw_heal <Target> <0|1> [Turns off/on team wound healing]");
	plugin_registercmd("admin_autoquad", "admin_autoquad", ACCESS_KICK, "admin_tw_heal <0|1> [Turns off/on random quad damage at round start]");


	exec( "logd_reg 62 admin_command quad_pick" );

	return PLUGIN_CONTINUE;
}
